execute at @a[scores={wake_up=1..10}] run place structure fortress ~ ~ ~
#player
execute if entity @s[scores={sleep=1..}] if predicate nightmare:random run execute in nightmare:nightmare run tp @s ~ ~ ~
execute if entity @s[scores={bed_tp=1..}] if dimension overworld run tp @s @e[tag=bed_spawn,limit=1]
execute if entity @s[scores={bed_tp=1..}] unless block ~ ~ ~ air run tp @s ~ ~1 ~
execute if entity @s[scores={bed_tp=1..}] unless block ~ ~ ~ #beds run tp @s ~ ~1 ~
execute if entity @s[scores={bed_tp=1..}] if block ~ ~ ~ air run scoreboard players reset @s bed_tp
execute if entity @s[scores={bed_tp=1..}] if block ~ ~ ~ #beds run scoreboard players reset @s bed_tp

#sleep
execute if entity @s[scores={sleep=1..}] run summon armor_stand ~ ~-1 ~ {Tags:["bed_spawn"],Invulnerable:1b,Invisible:1b}
execute as @e[tag=bed_spawn] run item replace entity @s armor.head with player_head{dream_stuff:1b}

#timer
execute if entity @s[scores={wake_up=2999..2999}] run title @s title {"text": "WAKE UP","bold": true,"color": "dark_red"}
execute if entity @s[scores={wake_up=3000..}] run tp @s @e[tag=sleep_spawn,limit=1]
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run kill @e[tag=sleep_spawn]
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run kill @e[tag=too_far1]
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run kill @e[tag=too_far2]
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run effect clear @s
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run scoreboard players set @s bed_tp 1
execute if entity @s[scores={wake_up=3006..},predicate=nightmare:sneaking] run execute in overworld run tp @s ~ ~ ~

#mob
execute if entity @e[tag=bed_spawn,distance=..2] unless score @s wake_up matches 1.. run kill @e[tag=bed_spawn,distance=..2]
execute as @e[tag=sleep_spawn] if entity @a if dimension overworld run kill @s
execute if entity @s unless score @s wake_up matches 1.. run clear @s elytra{dream_stuff:1b}
execute if entity @s unless score @s wake_up matches 1.. run clear @s enchanted_golden_apple{dream_stuff:1b}
execute if entity @s unless score @s wake_up matches 1.. run clear @s totem_of_undying{dream_stuff:1b}
execute if entity @s unless score @s wake_up matches 1.. run clear @s firework_rocket{dream_stuff:1b}
execute if entity @s[scores={wake_up=3000..}] if entity @e[tag=sleep_spawn,distance=..1] run clear @s elytra{dream_stuff:1b}
execute if entity @s if entity @e[tag=too_far1,distance=50..] if dimension nightmare:nightmare run tp @e[tag=too_far1] @s
execute if entity @s if entity @e[tag=too_far2,distance=50..] if dimension nightmare:nightmare run tp @e[tag=too_far2] @s
execute if entity @s if entity @e[type=item,distance=1..] if dimension nightmare:nightmare run kill @e[type=item]
execute at @e[tag=sleep_spawn] if block ~ ~-1 ~ nether_bricks run tp @e[tag=sleep_spawn] ~ ~1 ~

#score
execute if entity @s if dimension nightmare:nightmare run scoreboard players add @s wake_up 1
execute if entity @s unless dimension nightmare:nightmare run scoreboard players reset @s wake_up

#effects
execute if entity @s[scores={wake_up=1..}] run effect give @s regeneration 1 1 true
execute if entity @s[scores={wake_up=1..}] run effect give @s slow_falling 1 0 true
execute if entity @s[scores={wake_up=1..}] run effect give @s slowness 1 1 true
execute if entity @s[scores={wake_up=1..}] run effect give @s weakness 1 1 true
execute if entity @s[scores={wake_up=1..}] run effect give @s darkness 1 0 true
execute if entity @s[scores={bed_tp=1..}] run effect give @s saturation 2 1 true

#items
execute if entity @s[scores={wake_up=10..10}] run item replace entity @s container.8 with firework_rocket{dream_stuff:1b} 2
execute if entity @s[scores={wake_up=10..10}] run item replace entity @s container.7 with enchanted_golden_apple{dream_stuff:1b} 1
execute if entity @s[scores={wake_up=10..10}] run item replace entity @s container.6 with totem_of_undying{dream_stuff:1b}
execute if entity @s[scores={wake_up=10..10}] run item replace entity @s armor.chest with elytra{dream_stuff:1b}
execute if entity @s[nbt={SelectedItem:{tag:{dream_stuff:1b}}}] run clear @s player_head{dream_stuff:1b}
kill @e[type=item,nbt={Item:{tag:{dream_stuff:1b}}}]